searchData={"items":[{"type":"module","title":"OpenRtbEcto","doc":"Ecto schemas for OpenRTB 2.x & 3.0 according to the following specifications:\n\n[OpenRTB 2.0 Spec](https://www.iab.com/wp-content/uploads/2015/06/OpenRTB_API_Specification_Version2_0_FINAL.pdf)\n[OpenRTB 2.5 Spec](https://www.iab.com/wp-content/uploads/2016/03/OpenRTB-API-Specification-Version-2-5-FINAL.pdf)\n[OpenRTB 2.6 Spec](https://iabtechlab.com/wp-content/uploads/2022/04/OpenRTB-2-6_FINAL.pdf)\n\n[OpenRTB 3.0 Spec](https://iabtechlab.com/wp-content/uploads/2017/09/OpenRTB-3.0-Draft-Framework-for-Public-Comment.pdf)","ref":"OpenRtbEcto.html"},{"type":"function","title":"OpenRtbEcto.cast/2","doc":"","ref":"OpenRtbEcto.html#cast/2"},{"type":"type","title":"OpenRtbEcto.open_rtb_schema/0","doc":"Any of the schemas defined in the library","ref":"OpenRtbEcto.html#t:open_rtb_schema/0"},{"type":"module","title":"OpenRtbEcto.Types.TinyInt","doc":"In some cases, partners will send boolean values in the JSON payloads for fields that\nare defined as integers in the spec. This type can handle those cases and properly cast the\nvalues.","ref":"OpenRtbEcto.Types.TinyInt.html"},{"type":"function","title":"OpenRtbEcto.Types.TinyInt.cast/1","doc":"","ref":"OpenRtbEcto.Types.TinyInt.html#cast/1"},{"type":"function","title":"OpenRtbEcto.Types.TinyInt.dump/1","doc":"","ref":"OpenRtbEcto.Types.TinyInt.html#dump/1"},{"type":"function","title":"OpenRtbEcto.Types.TinyInt.embed_as/1","doc":"","ref":"OpenRtbEcto.Types.TinyInt.html#embed_as/1"},{"type":"function","title":"OpenRtbEcto.Types.TinyInt.equal?/2","doc":"","ref":"OpenRtbEcto.Types.TinyInt.html#equal?/2"},{"type":"function","title":"OpenRtbEcto.Types.TinyInt.load/1","doc":"","ref":"OpenRtbEcto.Types.TinyInt.html#load/1"},{"type":"function","title":"OpenRtbEcto.Types.TinyInt.type/0","doc":"","ref":"OpenRtbEcto.Types.TinyInt.html#type/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest","doc":"The top-level bid request object contains a globally unique bid request or auction ID. This id attribute is\nrequired as is at least one impression object (Section 3.2.4). Other attributes in this top-level object\nestablish rules and restrictions that apply to all impressions being offered.\n\nThere are also several subordinate objects that provide detailed data to potential buyers. Among these\nare the Site and App objects, which describe the type of published media in which the impression(s)\nappear. These objects are highly recommended, but only one applies to a given bid request depending\non whether the media is browser-based web content or a non-browser application, respectively.","ref":"OpenRtbEcto.V2.BidRequest.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.App","doc":"This object should be included if the ad supported content is a non-browser application (typically in\nmobile) as opposed to a website. A bid request must not contain both an App and a Site object. At a\nminimum, it is useful to provide an App ID or bundle, but this is not strictly required.","ref":"OpenRtbEcto.V2.BidRequest.App.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.App.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.App.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.App.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.App.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Audio","doc":"This object represents an audio type impression. Many of the fields are non-essential for minimally\nviable transactions, but are included to offer fine control when needed. Audio in OpenRTB generally\nassumes compliance with the DAAST standard. As such, the notion of companion ads is supported by\noptionally including an array of Banner objects (refer to the Banner object in Section 3.2.6) that define\nthese companion ads.\n\nThe presence of a Audio as a subordinate of the Imp object indicates that this impression is offered as\nan audio type impression. At the publisher’s discretion, that same impression may also be offered as\nbanner, video, and/or native by also including as Imp subordinates objects of those types. However, any\ngiven bid for the impression must conform to one of the offered types.","ref":"OpenRtbEcto.V2.BidRequest.Audio.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Audio.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Audio.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Audio.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Audio.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Banner","doc":"This object represents the most general type of impression. Although the term “banner” may have\nvery specific meaning in other contexts, here it can be many things including a simple static\nimage, an expandable ad unit, or even in-banner video (refer to the Video object in Section 3.2.7\nfor the more generalized and full featured video ad units). An array of Banner objects can also\nappear within the Video to describe optional companion ads defined in the VAST specification.\n\nThe presence of a Banner as a subordinate of the Imp object indicates that this impression is\noffered as a banner type impression. At the publisher’s discretion, that same impression may\nalso be offered as video, audio, and/or native by also including as Imp subordinates objects\nof those types. However, any given bid for the impression must conform to one of the offered\ntypes.","ref":"OpenRtbEcto.V2.BidRequest.Banner.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Banner.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Banner.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Banner.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Banner.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.BrandVersion","doc":"Further identification based on User-Agent Client Hints, the BrandVersion object is used to identify a\ndevice’s browser or similar software component, and the user agent’s execution platform or operating\nsystem.","ref":"OpenRtbEcto.V2.BidRequest.BrandVersion.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.BrandVersion.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.BrandVersion.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.BrandVersion.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.BrandVersion.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Channel","doc":"This object describes the channel an ad will be displayed on. A Channel is defined as the entity that curates\na content library, or stream within a brand name for viewers. Examples are specific view selectable\n‘channels’ within linear and streaming television (MTV, HGTV, CNN, BBC One, etc) or a specific stream of\naudio content commonly called ‘stations.’ Name is a human-readable field while domain and id can be used\nfor reporting and targeting purposes. See 7.6 for further examples.","ref":"OpenRtbEcto.V2.BidRequest.Channel.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Channel.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Channel.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Channel.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Channel.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Content","doc":"This object describes the content in which the impression will appear, which may be syndicated or\nnonsyndicated content. This object may be useful when syndicated content contains impressions and\ndoes not necessarily match the publisher’s general content. The exchange might or might not have\nknowledge of the page where the content is running, as a result of the syndication method. For\nexample might be a video impression embedded in an iframe on an unknown web property or device.","ref":"OpenRtbEcto.V2.BidRequest.Content.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Content.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Content.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Content.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Content.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Data","doc":"The data and segment objects together allow additional data about the related object (e.g., user,\ncontent) to be specified. This data may be from multiple sources whether from the exchange itself\nor third parties as specified by the id field. A bid request can mix data objects from multiple\nproviders. The specific data providers in use should be published by the exchange a priori to its\nbidders.","ref":"OpenRtbEcto.V2.BidRequest.Data.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Data.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Data.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Data.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Data.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Deal","doc":"This object constitutes a specific deal that was struck a priori between a buyer and a seller.\nIts presence with the Pmp collection indicates that this impression is available under the \nterms of that deal. Refer to Section 7.3 for more details.","ref":"OpenRtbEcto.V2.BidRequest.Deal.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Deal.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Deal.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Deal.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Deal.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Device","doc":"This object provides information pertaining to the device through which the user is interacting.\nDevice information includes its hardware, platform, location, and carrier data. The device can\nrefer to a mobile handset, a desktop computer, set top box, or other digital device.","ref":"OpenRtbEcto.V2.BidRequest.Device.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Device.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Device.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Device.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Device.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Eids","doc":"Extended identifiers support in the OpenRTB specification allows buyers to use audience data in real-time\nbidding. This object can contain one or more UIDs from a single source or a technology provider. The\nexchange should ensure that business agreements allow for the sending of this data.","ref":"OpenRtbEcto.V2.BidRequest.Eids.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Eids.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Eids.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Eids.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Eids.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Format","doc":"This object represents an allowed size (i.e., height and width combination) or Flex Ad parameters\nfor a banner impression. These are typically used in an array where multiple sizes are permitted.\nIt is recommended that either the w/h pair or the wratio/hratio/wmin set (i.e., for Flex Ads) be\nspecified.","ref":"OpenRtbEcto.V2.BidRequest.Format.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Format.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Format.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Format.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Format.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Geo","doc":"This object encapsulates various methods for specifying a geographic location. When subordinate\nto a Device object, it indicates the location of the device which can also be interpreted as the\nuser’s current location. When subordinate to a User object, it indicates the location of the \nuser’s home base (i.e., not necessarily their current location).\n\nThe lat/lon attributes should only be passed if they conform to the accuracy depicted in the type\nattribute. For example, the centroid of a geographic region such as postal code should not be \npassed.","ref":"OpenRtbEcto.V2.BidRequest.Geo.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Geo.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Geo.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Geo.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Geo.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Imp","doc":"This object describes an ad placement or impression being auctioned. A single bid request can\ninclude multiple Imp objects, a use case for which might be an exchange that supports selling all\nad positions on a given page. Each Imp object has a required ID so that bids can reference them\nindividually.\n\nThe presence of Banner (Section 3.2.6), Video (Section 3.2.7), and/or Native (Section 3.2.9)\nobjects subordinate to the Imp object indicates the type of impression being offered. The\npublisher can choose one such type which is the typical case or mix them at their discretion.\nHowever, any given bid for the impression must conform to one of the offered types.","ref":"OpenRtbEcto.V2.BidRequest.Imp.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Imp.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Imp.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Imp.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Imp.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Metric","doc":"This object is associated with an impression as an array of metrics. These metrics can offer\ninsight into the impression to assist with decisioning such as average recent viewability,\nclick-through rate, etc. Each metric is identified by its type, reports the value of the metric,\nand optionally identifies the source or vendor measuring the value.","ref":"OpenRtbEcto.V2.BidRequest.Metric.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Metric.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Metric.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Metric.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Metric.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Native","doc":"This object represents a native type impression. Native ad units are intended to blend seamlessly\ninto the surrounding content (e.g., a sponsored Twitter or Facebook post). As such, the response\nmust be well-structured to afford the publisher fine-grained control over rendering.\n\nThe Native Subcommittee has developed a companion specification to OpenRTB called the Dynamic\nNative Ads API. It defines the request parameters and response markup structure of native ad\nunits. This object provides the means of transporting request parameters as an opaque string so\nthat the specific parameters can evolve separately under the auspices of the Dynamic Native Ads\nAPI. Similarly, the ad markup served will be structured according to that specification.\n\nThe presence of a Native as a subordinate of the Imp object indicates that this impression is\noffered as a native type impression. At the publisher’s discretion, that same impression may also\nbe offered as banner, video, and/or audio by also including as Imp subordinates objects of those\ntypes. However, any given bid for the impression must conform to one of the offered types.","ref":"OpenRtbEcto.V2.BidRequest.Native.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Native.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Native.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Native.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Native.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Network","doc":"This object describes the network an ad will be displayed on. A Network is defined as the parent entity of\nthe Channel object’s entity for the purposes of organizing Channels. Examples are companies that own\nand/or license a collection of content channels (Viacom, Discovery, CBS, WarnerMedia, Turner and others),\nor studio that creates such content and self-distributes content. Name is a human-readable field while\ndomain and id can be used for reporting and targeting purposes. See 7.6 for further examples.","ref":"OpenRtbEcto.V2.BidRequest.Network.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Network.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Network.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Network.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Network.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Pmp","doc":"This object is the private marketplace container for direct deals between buyers and sellers that\nmay pertain to this impression. The actual deals are represented as a collection of Deal objects.\nRefer to Section 7.3 for more details.","ref":"OpenRtbEcto.V2.BidRequest.Pmp.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Pmp.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Pmp.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Pmp.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Pmp.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Producer","doc":"This object defines the producer of the content in which the ad will be shown. This is\nparticularly useful when the content is syndicated and may be distributed through different publishers\nand thus when the producer and publisher are not necessarily the same entity.","ref":"OpenRtbEcto.V2.BidRequest.Producer.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Producer.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Producer.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Producer.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Producer.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Publisher","doc":"This object describes the publisher of the media in which the ad will be displayed. The publisher\nis typically the seller in an OpenRTB transaction.","ref":"OpenRtbEcto.V2.BidRequest.Publisher.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Publisher.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Publisher.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Publisher.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Publisher.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Regs","doc":"This object contains any legal, governmental, or industry regulations that apply to the request.\nThe coppa flag signals whether or not the request falls under the United States Federal Trade\nCommission’s regulations for the United States Children’s Online Privacy Protection Act (“COPPA”).","ref":"OpenRtbEcto.V2.BidRequest.Regs.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Regs.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Regs.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Regs.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Regs.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Segment","doc":"Segment objects are essentially key-value pairs that convey specific units of data. The parent Data\nobject is a collection of such values from a given data provider. The specific segment names and value\noptions must be published by the exchange a priori to its bidders.","ref":"OpenRtbEcto.V2.BidRequest.Segment.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Segment.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Segment.html#changeset/2"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Site","doc":"This object should be included if the ad supported content is a website as opposed to a\nnon-browser application. A bid request must not contain both a Site and an App object. At a\nminimum, it is useful to provide a site ID or page URL, but this is not strictly required.","ref":"OpenRtbEcto.V2.BidRequest.Site.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Site.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Site.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Site.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Site.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Source","doc":"This object describes the nature and behavior of the entity that is the source of the bid request\nupstream from the exchange. The primary purpose of this object is to define post-auction or\nupstream decisioning when the exchange itself does not control the final decision. A common\nexample of this is header bidding, but it can also apply to upstream server entities such as\nanother RTB exchange, a mediation platform, or an ad server combines direct campaigns with 3rd\nparty demand in decisioning.","ref":"OpenRtbEcto.V2.BidRequest.Source.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Source.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Source.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Source.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Source.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.SupplyChain","doc":"This object is composed of a set of nodes where each node represents a specific entity that participates in\nthe transacting of inventory. The entire chain of nodes from beginning to end represents all entities who\nare involved in the direct flow of payment for inventory. Detailed implementation examples can be found\nhere: https://github.com/InteractiveAdvertisingBureau/openrtb/blob/master/supplychainobject.md","ref":"OpenRtbEcto.V2.BidRequest.SupplyChain.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.SupplyChain.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.SupplyChain.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.SupplyChain.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.SupplyChain.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.SupplyChainNode","doc":"This object is associated with a SupplyChain object as an array of nodes. These nodes define the identity of\nan entity participating in the supply chain of a bid request. Detailed implementation examples can be found\nhere: https://github.com/InteractiveAdvertisingBureau/openrtb/blob/master/supplychainobject.md. The\nSupplyChainNode object contains the following attributes:","ref":"OpenRtbEcto.V2.BidRequest.SupplyChainNode.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.SupplyChainNode.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.SupplyChainNode.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.SupplyChainNode.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.SupplyChainNode.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Uid","doc":"This object contains a single user identifier provided as part of extended identifiers. The exchange should\nensure that business agreements allow for the sending of this data.","ref":"OpenRtbEcto.V2.BidRequest.Uid.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Uid.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Uid.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Uid.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Uid.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.User","doc":"This object contains information known or derived about the human user of the device (i.e., the\naudience for advertising). The user id is an exchange artifact and may be subject to rotation or\nother privacy policies. However, this user ID must be stable long enough to serve reasonably as\nthe basis for frequency capping and retargeting.","ref":"OpenRtbEcto.V2.BidRequest.User.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.User.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.User.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.User.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.User.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.UserAgent","doc":"Structured user agent information, which can be used when a client supports User-Agent Client Hints. If\nboth device.ua and device.sua are present in the bid request, device.sua should be considered the more\naccurate representation of the device attributes. This is because the device.ua may contain a frozen or\nreduced user agent string due to deprecation of user agent strings by browsers.","ref":"OpenRtbEcto.V2.BidRequest.UserAgent.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.UserAgent.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.UserAgent.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.UserAgent.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.UserAgent.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidRequest.Video","doc":"This object represents an in-stream video impression. Many of the fields are non-essential for\nminimally viable transactions, but are included to offer fine control when needed. Video in\nOpenRTB generally assumes compliance with the VAST standard. As such, the notion of companion ads\nis supported by optionally including an array of Banner objects (refer to the Banner object in\nSection 3.2.6) that define these companion ads.\n\nThe presence of a Video as a subordinate of the Imp object indicates that this impression is\noffered as a video type impression. At the publisher’s discretion, that same impression may also\nbe offered as banner, audio, and/or native by also including as Imp subordinates objects of those\ntypes. However, any given bid for the impression must conform to one of the offered types.","ref":"OpenRtbEcto.V2.BidRequest.Video.html"},{"type":"function","title":"OpenRtbEcto.V2.BidRequest.Video.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Video.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidRequest.Video.t/0","doc":"","ref":"OpenRtbEcto.V2.BidRequest.Video.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidResponse","doc":"This object is the top-level bid response object (i.e., the unnamed outer JSON object). The id attribute\nis a reflection of the bid request ID for logging purposes. Similarly, bidid is an optional response\ntracking ID for bidders. If specified, it can be included in the subsequent win notice call if the bidder\nwins. At least one seatbid object is required, which contains at least one bid for an impression. Other\nattributes are optional.\n\nTo express a “no-bid”, the options are to return an empty response with HTTP 204. Alternately if the\nbidder wishes to convey to the exchange a reason for not bidding, just a BidResponse object is\nreturned with a reason code in the nbr attribute.","ref":"OpenRtbEcto.V2.BidResponse.html"},{"type":"function","title":"OpenRtbEcto.V2.BidResponse.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidResponse.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidResponse.t/0","doc":"","ref":"OpenRtbEcto.V2.BidResponse.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidResponse.Bid","doc":"A SeatBid object contains one or more Bid objects, each of which relates to a specific impression\nin the bid request via the impid attribute and constitutes an offer to buy that impression for a \ngiven price.","ref":"OpenRtbEcto.V2.BidResponse.Bid.html"},{"type":"function","title":"OpenRtbEcto.V2.BidResponse.Bid.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidResponse.Bid.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidResponse.Bid.t/0","doc":"","ref":"OpenRtbEcto.V2.BidResponse.Bid.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.BidResponse.SeatBid","doc":"A bid response can contain multiple SeatBid objects, each on behalf of a different bidder seat and\neach containing one or more individual bids. If multiple impressions are presented in the request,\nthe group attribute can be used to specify if a seat is willing to accept any impressions that it\ncan win (default) or if it is only interested in winning any if it can win them all as a group.","ref":"OpenRtbEcto.V2.BidResponse.SeatBid.html"},{"type":"function","title":"OpenRtbEcto.V2.BidResponse.SeatBid.changeset/2","doc":"","ref":"OpenRtbEcto.V2.BidResponse.SeatBid.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.BidResponse.SeatBid.t/0","doc":"","ref":"OpenRtbEcto.V2.BidResponse.SeatBid.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native","doc":"Schemas for the [OpenRTB Native specification version 1.2](https://www.iab.com/wp-content/uploads/2018/03/OpenRTB-Native-Ads-Specification-Final-1.2.pdf)","ref":"OpenRtbEcto.V2.Native.html"},{"type":"module","title":"OpenRtbEcto.V2.Native.Helper","doc":"","ref":"OpenRtbEcto.V2.Native.Helper.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Helper.validate_media/1","doc":"Validates that there is max one item from the media list present in the changeset of the response and request\nasset objects.","ref":"OpenRtbEcto.V2.Native.Helper.html#validate_media/1"},{"type":"module","title":"OpenRtbEcto.V2.Native.Request","doc":"The Native Object defines the native advertising opportunity available for bid via this bid request.","ref":"OpenRtbEcto.V2.Native.Request.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Request.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Request.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Request.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Request.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Request.Asset","doc":"The main container object for each asset requested or supported by Exchange on behalf of the rendering client.","ref":"OpenRtbEcto.V2.Native.Request.Asset.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Request.Asset.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Asset.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Request.Asset.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Asset.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Request.Data","doc":"The Data Object is to be used for all non-core elements of the native unit such as Brand Name,\nRatings, Review Count, Stars, Download count, descriptions etc. It is also generic for\nfuture native elements not contemplated at the time of the writing of this document. In some cases,\nadditional recommendations are also included in the Data Asset Types table.","ref":"OpenRtbEcto.V2.Native.Request.Data.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Request.Data.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Data.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Request.Data.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Data.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Request.EventTracker","doc":"The event trackers object specifies the types of events the bidder can request to be tracked in the bid response,\nand which types of tracking are available for each event type, and is included as an array in the request.","ref":"OpenRtbEcto.V2.Native.Request.EventTracker.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Request.EventTracker.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Request.EventTracker.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Request.EventTracker.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Request.EventTracker.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Request.Img","doc":"The Image object to be used for all image elements of the Native ad such as Icons, Main Image, etc.","ref":"OpenRtbEcto.V2.Native.Request.Img.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Request.Img.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Img.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Request.Img.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Img.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Request.Title","doc":"The Title object is to be used for title element of the Native ad.","ref":"OpenRtbEcto.V2.Native.Request.Title.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Request.Title.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Title.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Request.Title.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Title.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Request.Video","doc":"The video object to be used for all video elements supported in the Native Ad.\nThis corresponds to the Video object of OpenRTB.","ref":"OpenRtbEcto.V2.Native.Request.Video.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Request.Video.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Video.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Request.Video.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Request.Video.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Response","doc":"The native object is the top level JSON object which identifies a native response.","ref":"OpenRtbEcto.V2.Native.Response.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Response.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Response.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Response.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Response.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Response.Asset","doc":"Corresponds to the Asset Object in the request. The main container object for each asset requested or\nsupported by Exchange on behalf of the rendering client. Any object that is required is to be flagged as such.\nOnly one of the {title,img,video,data} objects should be present in each object. All others should be null/absent.\nThe id is to be unique within the AssetObject array so that the response can be aligned.","ref":"OpenRtbEcto.V2.Native.Response.Asset.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Response.Asset.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Asset.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Response.Asset.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Asset.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Response.Data","doc":"Corresponds to the Data Object in the request, with the value filled in.\nThe Data Object is to be used for all miscellaneous elements of the native unit such as\nBrand Name, Ratings, Review Count, Stars, Downloads, Price count etc. It is also generic for\nfuture native elements not contemplated at the time of the writing of this document.","ref":"OpenRtbEcto.V2.Native.Response.Data.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Response.Data.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Data.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Response.Data.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Data.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Response.EventTracker","doc":"The event trackers response is an array of objects and specifies the types of events the bidder\nwishes to track and the URLs/information to track them. Bidder must only respond with methods\nindicated as available in the request. Note that most javascript trackers expect to be loaded at\nimpression time, so it’s not generally recommended for the buyer to respond with javascript trackers on\nother events, but the appropriateness of this is up to each buyer.","ref":"OpenRtbEcto.V2.Native.Response.EventTracker.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Response.EventTracker.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Response.EventTracker.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Response.EventTracker.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Response.EventTracker.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Response.Img","doc":"Corresponds to the Image Object in the request. The Image object to be used for all\nimage elements of the Native ad such as Icons, Main Image, etc.","ref":"OpenRtbEcto.V2.Native.Response.Img.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Response.Img.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Img.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Response.Img.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Img.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Response.Link","doc":"Used for ‘call to action’ assets, or other links from the Native ad.\nThis Object should be associated to its peer object in the parent Asset Object or as\nthe master link in the top level Native Ad response object. When that peer object is\nactivated (clicked) the action should take the user to the location of the link.","ref":"OpenRtbEcto.V2.Native.Response.Link.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Response.Link.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Link.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Response.Link.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Link.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Response.Title","doc":"Corresponds to the Title Object in the request, with the value filled in.","ref":"OpenRtbEcto.V2.Native.Response.Title.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Response.Title.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Title.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Response.Title.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Title.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V2.Native.Response.Video","doc":"Corresponds to the Video Object in the request, yet containing a value of a conforming VAST tag as a value.","ref":"OpenRtbEcto.V2.Native.Response.Video.html"},{"type":"function","title":"OpenRtbEcto.V2.Native.Response.Video.changeset/2","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Video.html#changeset/2"},{"type":"type","title":"OpenRtbEcto.V2.Native.Response.Video.t/0","doc":"","ref":"OpenRtbEcto.V2.Native.Response.Video.html#t:t/0"},{"type":"module","title":"OpenRtbEcto.V3.BidRequest","doc":"#","ref":"OpenRtbEcto.V3.BidRequest.html"},{"type":"module","title":"Bid Request Payload - OpenRtbEcto.V3.BidRequest","doc":"The request object contains minimal high level attributes (e.g., its ID, test mode, auction type, maximum auction time, buyer restrictions, etc.) and subordinate objects that cover the source of the request and the actual offer of sale. The latter includes the item(s) being offered and any applicable deals.\n\nThere are two points in this model that interface to Layer-4 domain objects: the `Request` object and the `Item` object. Domain objects included under `Request` would include those that provide context for the overall offer. These would include objects that describe the site or app, the device, the user, and others. Domain objects included in an `Item` object would specify details about the item being offered (e.g., the impression opportunity) and specifications and restrictions on the media that can be associated with acceptable bids.\n\n \n   \n      Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Definition  \n   \n   \n      id  \n     string;&nbsp;required \n     Unique ID of the bid request; provided by the exchange. \n   \n   \n      test  \n     integer; default&nbsp;0 \n     Indicator of test mode in which auctions are not billable, where 0 = live mode, 1 = test mode. \n   \n   \n      tmax  \n     integer \n     Maximum time in milliseconds the exchange allows for bids to be received including Internet latency to avoid timeout. This value supersedes any  a priori  guidance from the exchange.  If an exchange acts as an intermediary, it should decrease the outbound  tmax  value from what it received to account for its latency and the additional internet hop. \n   \n   \n      at  \n     integer; default&nbsp;2 \n     Auction type, where 1 = First Price, 2 = Second Price Plus.  Values greater than 500 can be used for exchange-specific auction types. \n   \n   \n      cur  \n     string&nbsp;array; default&nbsp;[“USD”] \n     Array of accepted currencies for bids on this bid request using ISO-4217 alpha codes. Recommended if the exchange accepts multiple currencies. If omitted, the single currency of “USD” is assumed. \n   \n   \n      seat  \n     string&nbsp;array \n     Restriction list of buyer seats for bidding on this item.  Knowledge of buyer’s customers and their seat IDs must be coordinated between parties  a priori . Omission implies no restrictions. \n   \n   \n      wseat  \n     integer; default&nbsp;1 \n     Flag that determines the restriction interpretation of the  seat  array, where 0 = block list, 1 = whitelist. \n   \n   \n      cdata  \n     string \n     Allows bidder to retrieve data set on its behalf in the exchange’s cookie (refer to  cdata  in  Object: Response ) if supported by the exchange. The string must be in base85 cookie-safe characters. \n   \n   \n      source  \n     object \n     A  Source  object that provides data about the inventory source and which entity makes the final decision. Refer to  Object: Source . \n   \n   \n      item  \n     object&nbsp;array; required \n     Array of  Item  objects (at least one) that constitute the set of goods being offered for sale. Refer to  Object: Item . \n   \n   \n      package  \n     integer \n     Flag to indicate if the Exchange can verify that the items offered represent all of the items available in context (e.g., all impressions on a web page, all video spots such as pre/mid/post roll) to support road-blocking, where 0 = no, 1 = yes. \n   \n   \n      context  \n     object; recommended \n     Layer-4 domain object structure that provides context for the items being offered conforming to the specification and version referenced in  openrtb.domainspec  and  openrtb.domainver .  \n  For AdCOM v1.x, the objects allowed here all of which are optional are one of the  DistributionChannel  subtypes (i.e.,  Site ,  App , or  Dooh ),  User ,  Device ,  Regs ,  Restrictions , and any objects subordinate to these as specified by AdCOM. \n   \n   \n      ext  \n     object \n     Optional exchange-specific extensions.","ref":"OpenRtbEcto.V3.BidRequest.html#module-bid-request-payload"},{"type":"module","title":"OpenRtbEcto.V3.BidRequest.Deal","doc":"This object constitutes a specific deal that was struck *a priori* between a seller and a buyer.  Its presence indicates that this item is available under the terms of that deal.\n\n \n   \n      Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Definition  \n   \n   \n      id  \n     string; required \n     A unique identifier for the deal. \n   \n   \n      flr  \n     float \n     Minimum deal price for this item expressed in CPM. \n   \n   \n      flrcur  \n     string; default&nbsp;\"USD\" \n     Currency of the  flr  attribute specified using ISO-4217 alpha codes. \n   \n   \n      at  \n     integer \n     Optional override of the overall auction type of the request, where 1 = First Price, 2 = Second Price Plus, 3 = the value passed in  flr  is the agreed upon deal price.  Additional auction types can be defined by the exchange using 500+ values. \n   \n   \n      wseat  \n     string&nbsp;array \n     Whitelist of buyer seats allowed to bid on this deal.  IDs of seats and the buyer’s customers to which they refer must be coordinated between bidders and the exchange  a priori .  Omission implies no restrictions. \n   \n   \n      wadomain  \n     string&nbsp;array \n     Array of advertiser domains (e.g., advertiser.com) allowed to bid on this deal.  Omission implies no restrictions. \n   \n   \n      ext  \n     object \n     Optional exchange-specific extensions.","ref":"OpenRtbEcto.V3.BidRequest.Deal.html"},{"type":"function","title":"OpenRtbEcto.V3.BidRequest.Deal.changeset/2","doc":"","ref":"OpenRtbEcto.V3.BidRequest.Deal.html#changeset/2"},{"type":"module","title":"OpenRtbEcto.V3.BidRequest.Item","doc":"This object represents a unit of goods being offered for sale either on the open market or in relation to a private marketplace deal.  The `id` attribute is required since there may be multiple items being offered in the same bid request and bids must reference the specific item of interest.  This object interfaces to Layer-4 domain objects for deeper specification of the item being offered (e.g., an impression).\n\n \n   \n      Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Definition  \n   \n   \n      id  \n     string; required \n     A unique identifier for this item within the context of the offer (typically starts with “1” and increments). \n   \n   \n      qty  \n     integer; default&nbsp;1 \n     The number of instances (i.e., “quantity”) of this item being offered (e.g., multiple identical impressions in a digital out-of-home scenario). \n   \n   \n      seq  \n     integer \n     If multiple items are offered in the same bid request, the sequence number allows for the coordinated delivery. \n   \n   \n      flr  \n     float \n     Minimum bid price for this item expressed in CPM. \n   \n   \n      flrcur  \n     string; default&nbsp;“USD” \n     Currency of the  flr  attribute specified using ISO-4217 alpha codes. \n   \n   \n      exp  \n     integer \n     Advisory as to the number of seconds that may elapse between auction and fulfilment. \n   \n   \n      dt  \n     integer \n     Timestamp when the item is expected to be fulfilled (e.g. when a DOOH impression will be displayed) in Unix format (i.e., milliseconds since the epoch). \n   \n   \n      dlvy  \n     integer; default&nbsp;0 \n     Item (e.g., an Ad object) delivery method required, where 0 = either method, 1 = the item must be sent as part of the transaction (e.g., by value in the bid itself, fetched by URL included in the bid), and 2 = an item previously uploaded to the exchange must be referenced by its ID.  Note that if an exchange does not supported prior upload, then the default of 0 is effectively the same as 1 since there can be no items to reference. \n   \n   \n      metric  \n     object&nbsp;array \n     An array of  Metric  objects.  Refer to  Object: Metric . \n   \n   \n      deal  \n     object&nbsp;array \n     Array of  Deal  objects that convey special terms applicable to this item.  Refer to  Object: Deal . \n   \n   \n      private  \n     integer; default&nbsp;0 \n     Indicator of auction eligibility to seats named in  Deal  objects, where 0 = all bids are accepted, 1 = bids are restricted to the deals specified and the terms thereof. \n   \n   \n      spec  \n     object; required \n     Layer-4 domain object structure that provides specifies the item being offered conforming to the specification and version referenced in  openrtb.domainspec  and  openrtb.domainver .  \n  For AdCOM v1.x, the objects allowed here are  Placement  and any objects subordinate to these as specified by AdCOM. \n   \n   \n      ext  \n     object \n     Optional exchange-specific extensions.","ref":"OpenRtbEcto.V3.BidRequest.Item.html"},{"type":"function","title":"OpenRtbEcto.V3.BidRequest.Item.changeset/2","doc":"","ref":"OpenRtbEcto.V3.BidRequest.Item.html#changeset/2"},{"type":"module","title":"OpenRtbEcto.V3.BidRequest.Metric","doc":"This object is associated with an item as an array of metrics. These metrics can offer insight to assist with decisioning such as average recent viewability, click-through rate, etc.  Each metric is identified by its type, reports the value of the metric, and optionally identifies the source or vendor measuring the value.\n\n \n   \n      Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Definition  \n   \n   \n      type  \n     string; required \n     Type of metric being presented using exchange curated string names which should be published to bidders  a priori . \n   \n   \n      value  \n     float; required \n     Number representing the value of the metric.  Probabilities must be in the range 0.0 – 1.0. \n   \n   \n      vendor  \n     string; recommended \n     Source of the value using exchange curated string names which should be published to bidders  a priori .  If the exchange itself is the source versus a third party, “EXCHANGE” is recommended. \n   \n   \n      ext  \n     object \n     Optional exchange-specific extensions.","ref":"OpenRtbEcto.V3.BidRequest.Metric.html"},{"type":"function","title":"OpenRtbEcto.V3.BidRequest.Metric.changeset/2","doc":"","ref":"OpenRtbEcto.V3.BidRequest.Metric.html#changeset/2"},{"type":"module","title":"OpenRtbEcto.V3.BidRequest.Request","doc":"The `Request` object contains a globally unique bid request ID. This `id` attribute is required as is an `Item` array with at least one object (i.e., at least one item for sale).  Other attributes establish rules and restrictions that apply to all items being offered. This object also interfaces to Layer-4 domain objects for context such as the user, device, site or app, etc.\n\n \n   \n      Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Definition  \n   \n   \n      id  \n     string;&nbsp;required \n     Unique ID of the bid request; provided by the exchange. \n   \n   \n      test  \n     integer; default&nbsp;0 \n     Indicator of test mode in which auctions are not billable, where 0 = live mode, 1 = test mode. \n   \n   \n      tmax  \n     integer \n     Maximum time in milliseconds the exchange allows for bids to be received including Internet latency to avoid timeout. This value supersedes any  a priori  guidance from the exchange.  If an exchange acts as an intermediary, it should decrease the outbound  tmax  value from what it received to account for its latency and the additional internet hop. \n   \n   \n      at  \n     integer; default&nbsp;2 \n     Auction type, where 1 = First Price, 2 = Second Price Plus.  Values greater than 500 can be used for exchange-specific auction types. \n   \n   \n      cur  \n     string&nbsp;array; default&nbsp;[“USD”] \n     Array of accepted currencies for bids on this bid request using ISO-4217 alpha codes. Recommended if the exchange accepts multiple currencies. If omitted, the single currency of “USD” is assumed. \n   \n   \n      seat  \n     string&nbsp;array \n     Restriction list of buyer seats for bidding on this item.  Knowledge of buyer’s customers and their seat IDs must be coordinated between parties  a priori . Omission implies no restrictions. \n   \n   \n      wseat  \n     integer; default&nbsp;1 \n     Flag that determines the restriction interpretation of the  seat  array, where 0 = block list, 1 = whitelist. \n   \n   \n      cdata  \n     string \n     Allows bidder to retrieve data set on its behalf in the exchange’s cookie (refer to  cdata  in  Object: Response ) if supported by the exchange. The string must be in base85 cookie-safe characters. \n   \n   \n      source  \n     object \n     A  Source  object that provides data about the inventory source and which entity makes the final decision. Refer to  Object: Source . \n   \n   \n      item  \n     object&nbsp;array; required \n     Array of  Item  objects (at least one) that constitute the set of goods being offered for sale. Refer to  Object: Item . \n   \n   \n      package  \n     integer \n     Flag to indicate if the Exchange can verify that the items offered represent all of the items available in context (e.g., all impressions on a web page, all video spots such as pre/mid/post roll) to support road-blocking, where 0 = no, 1 = yes. \n   \n   \n      context  \n     object; recommended \n     Layer-4 domain object structure that provides context for the items being offered conforming to the specification and version referenced in  openrtb.domainspec  and  openrtb.domainver .  \n  For AdCOM v1.x, the objects allowed here all of which are optional are one of the  DistributionChannel  subtypes (i.e.,  Site ,  App , or  Dooh ),  User ,  Device ,  Regs ,  Restrictions , and any objects subordinate to these as specified by AdCOM. \n   \n   \n      ext  \n     object \n     Optional exchange-specific extensions.","ref":"OpenRtbEcto.V3.BidRequest.Request.html"},{"type":"function","title":"OpenRtbEcto.V3.BidRequest.Request.changeset/2","doc":"","ref":"OpenRtbEcto.V3.BidRequest.Request.html#changeset/2"},{"type":"module","title":"OpenRtbEcto.V3.BidRequest.Source","doc":"This object carries data about the source of the transaction including the unique ID of the transaction itself, source authentication information, and the chain of custody.\n\nNOTE:  Attributes `ds`, `dsmap`, `cert`, and `digest` support digitally signed bid requests as defined by the [Ads.cert: Signed Bid Requests specification](https://github.com/InteractiveAdvertisingBureau/openrtb/blob/master/ads.cert%201.0%20BETA.md).  As the Ads.cert specification is still in its BETA state, these attributes should be considered to be in a similar state.\n\n \n   \n      Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Definition  \n   \n   \n      tid  \n     string; recommended \n     Transaction ID that must be common across all participants throughout the entire supply chain of this transaction.  This also applies across all participating exchanges in a header bidding or similar publisher-centric broadcast scenario. \n   \n   \n      ts  \n     integer; recommended \n     Timestamp when the request originated at the beginning of the supply chain in Unix format (i.e., milliseconds since the epoch).  This value must be held as immutable throughout subsequent intermediaries. \n   \n   \n      ds  \n     string; recommended \n     Digital signature used to authenticate the origin of this request computed by the publisher or its trusted agent from a digest string composed of a set of immutable attributes found in the bid request.  Refer to Section “ Inventory Authentication ” for more details. \n   \n   \n      dsmap  \n     string \n     An ordered list of identifiers that indicates the attributes used to create the digest.  This map provides the essential instructions for recreating the digest from the bid request, which is a necessary step in validating the digital signature in the  ds  attribute.  Refer to Section “ Inventory Authentication ” for more details. \n   \n   \n      cert  \n     string; recommended \n     File name of the certificate (i.e., the public key) used to generate the digital signature in the  ds  attribute.  Refer to Section “ Inventory Authentication ” for more details. \n   \n   \n      digest  \n     string \n     The full digest string that was signed to produce the digital signature.  Refer to Section “ Inventory Authentication ” for more details. \n  NOTE:  This is only intended for debugging purposes as needed. It is not intended for normal Production traffic due to the bandwidth impact. \n   \n   \n      pchain  \n     string \n     Payment ID chain string containing embedded syntax described in the TAG Payment ID Protocol. \n  NOTE: Authentication features in this Source object combined with the “ads.txt” specification may lead to the deprecation of this attribute. \n   \n   \n      ext  \n     object \n     Optional exchange-specific extensions.","ref":"OpenRtbEcto.V3.BidRequest.Source.html"},{"type":"function","title":"OpenRtbEcto.V3.BidRequest.Source.changeset/2","doc":"","ref":"OpenRtbEcto.V3.BidRequest.Source.html#changeset/2"},{"type":"module","title":"OpenRtbEcto.V3.BidResponse","doc":"The response object contains minimal high level attributes (e.g., reference to the request ID, bid currency, etc.) and an array of seat bids, each of which is a set of bids on behalf of a buyer seat.\n\nThe individual bid references the item in the request to which it pertains and buying information such as the price, a deal ID if applicable, and notification URLs.  The media related to a bid is conveyed via Layer-4 domain objects (i.e., ad creative, markup) included in each bid.","ref":"OpenRtbEcto.V3.BidResponse.html"},{"type":"module","title":"OpenRtbEcto.V3.BidResponse.Bid","doc":"A `Seatbid` object contains one or more `Bid` objects, each of which relates to a specific item in the bid request offer via the “item” attribute and constitutes an offer to buy that item for a given price.\n\n \n   \n      Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Definition  \n   \n   \n      id  \n     string; recommended \n     Bidder generated bid ID to assist with logging/tracking. \n   \n   \n      item  \n     string; required \n     ID of the item object in the related bid request; specifically  item.id . \n   \n   \n      price  \n     float; required \n     Bid price expressed as CPM although the actual transaction is for a unit item only.  Note that while the type indicates float, integer math is highly recommended when handling currencies (e.g., BigDecimal in Java). \n   \n   \n      deal  \n     string \n     Reference to a deal from the bid request if this bid pertains to a private marketplace deal; specifically  deal.id . \n   \n   \n      cid  \n     string \n     Campaign ID or other similar grouping of brand-related ads.  Typically used to increase the efficiency of audit processes. \n   \n   \n      tactic  \n     string \n     Tactic ID to enable buyers to label bids for reporting to the exchange the tactic through which their bid was submitted.  The specific usage and meaning of the tactic ID should be communicated between buyer and exchanges  a priori . \n   \n   \n      purl  \n     string \n     Pending notice URL called by the exchange when a bid has been declared the winner within the scope of an OpenRTB compliant supply chain (i.e., there may still be non-compliant decisioning such as header bidding).  Substitution macros may be included. \n   \n   \n      burl  \n     string; recommended \n     Billing notice URL called by the exchange when a winning bid becomes billable based on exchange-specific business policy (e.g., markup rendered).  Substitution macros may be included. \n   \n   \n      lurl  \n     string \n     Loss notice URL called by the exchange when a bid is known to have been lost.  Substitution macros may be included.  Exchange-specific policy may preclude support for loss notices or the disclosure of winning clearing prices resulting in  ${OPENRTB_PRICE}  macros being removed (i.e., replaced with a zero-length string). \n   \n   \n      exp  \n     integer \n     Advisory as to the number of seconds the buyer is willing to wait between auction and fulfilment. \n   \n   \n      mid  \n     string \n     ID to enable media to be specified by reference if previously uploaded to the exchange rather than including it by value in the domain objects. \n   \n   \n      macro  \n     object&nbsp;array \n     Array of  Macro  objects that enable bid specific values to be substituted into markup; especially useful for previously uploaded media referenced via the  mid  attribute.  Refer to  Object: Macro . \n   \n   \n      media  \n     object \n     Layer-4 domain object structure that specifies the media to be presented if the bid is won conforming to the specification and version referenced in  openrtb.domainspec  and  openrtb.domainver .\n  For AdCOM v1.x, the objects allowed here are “Ad” and any objects subordinate thereto as specified by AdCOM. \n   \n   \n      ext  \n     object \n     Optional demand source specific extensions.","ref":"OpenRtbEcto.V3.BidResponse.Bid.html"},{"type":"function","title":"OpenRtbEcto.V3.BidResponse.Bid.changeset/2","doc":"","ref":"OpenRtbEcto.V3.BidResponse.Bid.html#changeset/2"},{"type":"module","title":"OpenRtbEcto.V3.BidResponse.Macro","doc":"This object constitutes a buyer defined key/value pair used to inject dynamic values into media markup.  While they apply to any media markup irrespective of how it is conveyed, the principle use case is for media that was uploaded to the exchange prior to the transaction (e.g., pre-registered for creative quality review) and referenced in bid.  The full form of the macro to be substituted at runtime is `${CUSTOM_KEY}`, where “`KEY`” is the name supplied in the `key` attribute.  This ensures no conflict with standard OpenRTB macros.\n\n \n   \n      Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Definition  \n   \n   \n      key  \n     string; required \n     Name of a buyer specific macro. \n   \n   \n      value  \n     string \n     Value to substitute for each instance of the macro found in markup. \n   \n   \n      ext  \n     object \n     Optional demand source specific extensions.","ref":"OpenRtbEcto.V3.BidResponse.Macro.html"},{"type":"function","title":"OpenRtbEcto.V3.BidResponse.Macro.changeset/2","doc":"","ref":"OpenRtbEcto.V3.BidResponse.Macro.html#changeset/2"},{"type":"module","title":"OpenRtbEcto.V3.BidResponse.Response","doc":"This object is the bid response object under the `Openrtb` root.  Its `id` attribute is a reflection of the bid request ID.  The `bidid` attribute is an optional response tracking ID for bidders.  If specified, it will be available for use in substitution macros placed in markup and notification URLs.  At least one `Seatbid` object is required, which contains at least one `Bid` for an item.  Other attributes are optional.\n\nTo express a “no-bid”, the most compact option is simply to return an empty response with HTTP 204.  However, if the bidder wishes to convey a reason for not bidding, a `Response` object can be returned with just a reason code in the `nbr` attribute.\n\n \n   \n      Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Definition  \n   \n   \n      id  \n     string; required \n     ID of the bid request to which this is a response; must match the  request.id  attribute. \n   \n   \n      bidid  \n     string \n     Bidder generated response ID to assist with logging/tracking. \n   \n   \n      nbr  \n     integer \n     Reason for not bidding if applicable (see  List: No-Bid Reason Codes ).  Note that while many exchanges prefer a simple HTTP 204 response to indicate a no-bid, responses indicating a reason code can be useful in debugging scenarios. \n   \n   \n      cur  \n     string; default&nbsp;“USD” \n     Bid currency using ISO-4217 alpha codes. \n   \n   \n      cdata  \n     string \n     Allows bidder to set data in the exchange’s cookie, which can be retrieved on bid requests (refer to  cdata  in  Object: Request ) if supported by the exchange.  The string must be in base85 cookie-safe characters. \n   \n   \n      seatbid  \n     object&nbsp;array \n     Array of  Seatbid  objects; 1+ required if a bid is to be made.  Refer to  Object: Seatbid . \n   \n   \n      ext  \n     object \n     Optional demand source specific extensions.","ref":"OpenRtbEcto.V3.BidResponse.Response.html"},{"type":"function","title":"OpenRtbEcto.V3.BidResponse.Response.changeset/2","doc":"","ref":"OpenRtbEcto.V3.BidResponse.Response.html#changeset/2"},{"type":"module","title":"OpenRtbEcto.V3.BidResponse.SeatBid","doc":"A bid response can contain multiple `Seatbid` objects, each on behalf of a different buyer seat and each containing one or more individual bids.  If multiple items are presented in the request offer, the `package` attribute can be used to specify if a seat is willing to accept any impressions that it can win (default) or if it is interested in winning any only if it can win them all as a group.\n\n \n   \n       Attribute&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n      Type&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  \n     Definition  \n   \n   \n      seat  \n     string, recommended \n     ID of the buyer seat on whose behalf this bid is made. \n   \n   \n      package  \n     integer; default&nbsp;0 \n     For offers with multiple items, this flag Indicates if the bidder is willing to accept wins on a subset of bids or requires the full group as a package, where 0 = individual wins accepted; 1 = package win or loss only. \n   \n   \n      bid  \n     object&nbsp;array; required \n     Array of 1+  Bid  objects each related to an item.  Multiple bids can relate to the same item.  Refer to  Object: Bid . \n   \n   \n      ext  \n     object \n     Optional demand source specific extensions.","ref":"OpenRtbEcto.V3.BidResponse.SeatBid.html"},{"type":"function","title":"OpenRtbEcto.V3.BidResponse.SeatBid.changeset/2","doc":"","ref":"OpenRtbEcto.V3.BidResponse.SeatBid.html#changeset/2"}],"content_type":"text/markdown"}